//                           _       _
// __      _____  __ ___   ___  __ _| |_ ___
// \ \ /\ / / _ \/ _` \ \ / / |/ _` | __/ _ \
//  \ V  V /  __/ (_| |\ V /| | (_| | ||  __/
//   \_/\_/ \___|\__,_| \_/ |_|\__,_|\__\___|
//
//  Copyright © 2016 - 2022 SeMI Technologies B.V. All rights reserved.
//
//  CONTACT: hello@semi.technology
//

// Code generated by go-swagger; DO NOT EDIT.

package schema

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/semi-technologies/weaviate/entities/models"
)

// SchemaObjectsSnapshotsCreateOKCode is the HTTP code returned for type SchemaObjectsSnapshotsCreateOK
const SchemaObjectsSnapshotsCreateOKCode int = 200

/*
SchemaObjectsSnapshotsCreateOK Snapshot process successfully started.

swagger:response schemaObjectsSnapshotsCreateOK
*/
type SchemaObjectsSnapshotsCreateOK struct {

	/*
	  In: Body
	*/
	Payload *models.SnapshotMeta `json:"body,omitempty"`
}

// NewSchemaObjectsSnapshotsCreateOK creates SchemaObjectsSnapshotsCreateOK with default headers values
func NewSchemaObjectsSnapshotsCreateOK() *SchemaObjectsSnapshotsCreateOK {

	return &SchemaObjectsSnapshotsCreateOK{}
}

// WithPayload adds the payload to the schema objects snapshots create o k response
func (o *SchemaObjectsSnapshotsCreateOK) WithPayload(payload *models.SnapshotMeta) *SchemaObjectsSnapshotsCreateOK {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the schema objects snapshots create o k response
func (o *SchemaObjectsSnapshotsCreateOK) SetPayload(payload *models.SnapshotMeta) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *SchemaObjectsSnapshotsCreateOK) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(200)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// SchemaObjectsSnapshotsCreateUnauthorizedCode is the HTTP code returned for type SchemaObjectsSnapshotsCreateUnauthorized
const SchemaObjectsSnapshotsCreateUnauthorizedCode int = 401

/*
SchemaObjectsSnapshotsCreateUnauthorized Unauthorized or invalid credentials.

swagger:response schemaObjectsSnapshotsCreateUnauthorized
*/
type SchemaObjectsSnapshotsCreateUnauthorized struct {
}

// NewSchemaObjectsSnapshotsCreateUnauthorized creates SchemaObjectsSnapshotsCreateUnauthorized with default headers values
func NewSchemaObjectsSnapshotsCreateUnauthorized() *SchemaObjectsSnapshotsCreateUnauthorized {

	return &SchemaObjectsSnapshotsCreateUnauthorized{}
}

// WriteResponse to the client
func (o *SchemaObjectsSnapshotsCreateUnauthorized) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.Header().Del(runtime.HeaderContentType) //Remove Content-Type on empty responses

	rw.WriteHeader(401)
}

// SchemaObjectsSnapshotsCreateForbiddenCode is the HTTP code returned for type SchemaObjectsSnapshotsCreateForbidden
const SchemaObjectsSnapshotsCreateForbiddenCode int = 403

/*
SchemaObjectsSnapshotsCreateForbidden Forbidden

swagger:response schemaObjectsSnapshotsCreateForbidden
*/
type SchemaObjectsSnapshotsCreateForbidden struct {

	/*
	  In: Body
	*/
	Payload *models.ErrorResponse `json:"body,omitempty"`
}

// NewSchemaObjectsSnapshotsCreateForbidden creates SchemaObjectsSnapshotsCreateForbidden with default headers values
func NewSchemaObjectsSnapshotsCreateForbidden() *SchemaObjectsSnapshotsCreateForbidden {

	return &SchemaObjectsSnapshotsCreateForbidden{}
}

// WithPayload adds the payload to the schema objects snapshots create forbidden response
func (o *SchemaObjectsSnapshotsCreateForbidden) WithPayload(payload *models.ErrorResponse) *SchemaObjectsSnapshotsCreateForbidden {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the schema objects snapshots create forbidden response
func (o *SchemaObjectsSnapshotsCreateForbidden) SetPayload(payload *models.ErrorResponse) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *SchemaObjectsSnapshotsCreateForbidden) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(403)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// SchemaObjectsSnapshotsCreateUnprocessableEntityCode is the HTTP code returned for type SchemaObjectsSnapshotsCreateUnprocessableEntity
const SchemaObjectsSnapshotsCreateUnprocessableEntityCode int = 422

/*
SchemaObjectsSnapshotsCreateUnprocessableEntity Invalid create snapshot attempt.

swagger:response schemaObjectsSnapshotsCreateUnprocessableEntity
*/
type SchemaObjectsSnapshotsCreateUnprocessableEntity struct {

	/*
	  In: Body
	*/
	Payload *models.ErrorResponse `json:"body,omitempty"`
}

// NewSchemaObjectsSnapshotsCreateUnprocessableEntity creates SchemaObjectsSnapshotsCreateUnprocessableEntity with default headers values
func NewSchemaObjectsSnapshotsCreateUnprocessableEntity() *SchemaObjectsSnapshotsCreateUnprocessableEntity {

	return &SchemaObjectsSnapshotsCreateUnprocessableEntity{}
}

// WithPayload adds the payload to the schema objects snapshots create unprocessable entity response
func (o *SchemaObjectsSnapshotsCreateUnprocessableEntity) WithPayload(payload *models.ErrorResponse) *SchemaObjectsSnapshotsCreateUnprocessableEntity {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the schema objects snapshots create unprocessable entity response
func (o *SchemaObjectsSnapshotsCreateUnprocessableEntity) SetPayload(payload *models.ErrorResponse) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *SchemaObjectsSnapshotsCreateUnprocessableEntity) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(422)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// SchemaObjectsSnapshotsCreateInternalServerErrorCode is the HTTP code returned for type SchemaObjectsSnapshotsCreateInternalServerError
const SchemaObjectsSnapshotsCreateInternalServerErrorCode int = 500

/*
SchemaObjectsSnapshotsCreateInternalServerError An error has occurred while trying to fulfill the request. Most likely the ErrorResponse will contain more information about the error.

swagger:response schemaObjectsSnapshotsCreateInternalServerError
*/
type SchemaObjectsSnapshotsCreateInternalServerError struct {

	/*
	  In: Body
	*/
	Payload *models.ErrorResponse `json:"body,omitempty"`
}

// NewSchemaObjectsSnapshotsCreateInternalServerError creates SchemaObjectsSnapshotsCreateInternalServerError with default headers values
func NewSchemaObjectsSnapshotsCreateInternalServerError() *SchemaObjectsSnapshotsCreateInternalServerError {

	return &SchemaObjectsSnapshotsCreateInternalServerError{}
}

// WithPayload adds the payload to the schema objects snapshots create internal server error response
func (o *SchemaObjectsSnapshotsCreateInternalServerError) WithPayload(payload *models.ErrorResponse) *SchemaObjectsSnapshotsCreateInternalServerError {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the schema objects snapshots create internal server error response
func (o *SchemaObjectsSnapshotsCreateInternalServerError) SetPayload(payload *models.ErrorResponse) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *SchemaObjectsSnapshotsCreateInternalServerError) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(500)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
