//                           _       _
// __      _____  __ ___   ___  __ _| |_ ___
// \ \ /\ / / _ \/ _` \ \ / / |/ _` | __/ _ \
//  \ V  V /  __/ (_| |\ V /| | (_| | ||  __/
//   \_/\_/ \___|\__,_| \_/ |_|\__,_|\__\___|
//
//  Copyright © 2016 - 2022 SeMI Technologies B.V. All rights reserved.
//
//  CONTACT: hello@semi.technology
//

// Code generated by go-swagger; DO NOT EDIT.

package schema

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime/middleware"
	"github.com/go-openapi/strfmt"
)

// NewSchemaObjectsSnapshotsRestoreParams creates a new SchemaObjectsSnapshotsRestoreParams object
// no default values defined in spec.
func NewSchemaObjectsSnapshotsRestoreParams() SchemaObjectsSnapshotsRestoreParams {

	return SchemaObjectsSnapshotsRestoreParams{}
}

// SchemaObjectsSnapshotsRestoreParams contains all the bound params for the schema objects snapshots restore operation
// typically these are obtained from a http.Request
//
// swagger:parameters schema.objects.snapshots.restore
type SchemaObjectsSnapshotsRestoreParams struct {

	// HTTP Request Object
	HTTPRequest *http.Request `json:"-"`

	/*The name of the class
	  Required: true
	  In: path
	*/
	ClassName string
	/*The ID of a snapshot. Must be URL-safe and work as a filesystem path, only lowercase, numbers, underscore, minus characters allowed.
	  Required: true
	  In: path
	*/
	ID string
	/*Storage name e.g. filesystem, gcs, s3.
	  Required: true
	  In: path
	*/
	StorageName string
}

// BindRequest both binds and validates a request, it assumes that complex things implement a Validatable(strfmt.Registry) error interface
// for simple values it will use straight method calls.
//
// To ensure default values, the struct must have been initialized with NewSchemaObjectsSnapshotsRestoreParams() beforehand.
func (o *SchemaObjectsSnapshotsRestoreParams) BindRequest(r *http.Request, route *middleware.MatchedRoute) error {
	var res []error

	o.HTTPRequest = r

	rClassName, rhkClassName, _ := route.Params.GetOK("className")
	if err := o.bindClassName(rClassName, rhkClassName, route.Formats); err != nil {
		res = append(res, err)
	}

	rID, rhkID, _ := route.Params.GetOK("id")
	if err := o.bindID(rID, rhkID, route.Formats); err != nil {
		res = append(res, err)
	}

	rStorageName, rhkStorageName, _ := route.Params.GetOK("storageName")
	if err := o.bindStorageName(rStorageName, rhkStorageName, route.Formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindClassName binds and validates parameter ClassName from path.
func (o *SchemaObjectsSnapshotsRestoreParams) bindClassName(rawData []string, hasKey bool, formats strfmt.Registry) error {
	var raw string
	if len(rawData) > 0 {
		raw = rawData[len(rawData)-1]
	}

	// Required: true
	// Parameter is provided by construction from the route

	o.ClassName = raw

	return nil
}

// bindID binds and validates parameter ID from path.
func (o *SchemaObjectsSnapshotsRestoreParams) bindID(rawData []string, hasKey bool, formats strfmt.Registry) error {
	var raw string
	if len(rawData) > 0 {
		raw = rawData[len(rawData)-1]
	}

	// Required: true
	// Parameter is provided by construction from the route

	o.ID = raw

	return nil
}

// bindStorageName binds and validates parameter StorageName from path.
func (o *SchemaObjectsSnapshotsRestoreParams) bindStorageName(rawData []string, hasKey bool, formats strfmt.Registry) error {
	var raw string
	if len(rawData) > 0 {
		raw = rawData[len(rawData)-1]
	}

	// Required: true
	// Parameter is provided by construction from the route

	o.StorageName = raw

	return nil
}
