//                           _       _
// __      _____  __ ___   ___  __ _| |_ ___
// \ \ /\ / / _ \/ _` \ \ / / |/ _` | __/ _ \
//  \ V  V /  __/ (_| |\ V /| | (_| | ||  __/
//   \_/\_/ \___|\__,_| \_/ |_|\__,_|\__\___|
//
//  Copyright © 2016 - 2022 SeMI Technologies B.V. All rights reserved.
//
//  CONTACT: hello@semi.technology
//

// Code generated by go-swagger; DO NOT EDIT.

package schema

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewSchemaObjectsSnapshotsCreateParams creates a new SchemaObjectsSnapshotsCreateParams object
// with the default values initialized.
func NewSchemaObjectsSnapshotsCreateParams() *SchemaObjectsSnapshotsCreateParams {
	var ()
	return &SchemaObjectsSnapshotsCreateParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewSchemaObjectsSnapshotsCreateParamsWithTimeout creates a new SchemaObjectsSnapshotsCreateParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewSchemaObjectsSnapshotsCreateParamsWithTimeout(timeout time.Duration) *SchemaObjectsSnapshotsCreateParams {
	var ()
	return &SchemaObjectsSnapshotsCreateParams{

		timeout: timeout,
	}
}

// NewSchemaObjectsSnapshotsCreateParamsWithContext creates a new SchemaObjectsSnapshotsCreateParams object
// with the default values initialized, and the ability to set a context for a request
func NewSchemaObjectsSnapshotsCreateParamsWithContext(ctx context.Context) *SchemaObjectsSnapshotsCreateParams {
	var ()
	return &SchemaObjectsSnapshotsCreateParams{

		Context: ctx,
	}
}

// NewSchemaObjectsSnapshotsCreateParamsWithHTTPClient creates a new SchemaObjectsSnapshotsCreateParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewSchemaObjectsSnapshotsCreateParamsWithHTTPClient(client *http.Client) *SchemaObjectsSnapshotsCreateParams {
	var ()
	return &SchemaObjectsSnapshotsCreateParams{
		HTTPClient: client,
	}
}

/*
SchemaObjectsSnapshotsCreateParams contains all the parameters to send to the API endpoint
for the schema objects snapshots create operation typically these are written to a http.Request
*/
type SchemaObjectsSnapshotsCreateParams struct {

	/*ClassName
	  The name of the class

	*/
	ClassName string
	/*ID
	  The ID of a snapshot. Must be URL-safe and work as a filesystem path, only lowercase, numbers, underscore, minus characters allowed.

	*/
	ID string
	/*StorageName
	  Storage name e.g. filesystem, gcs, s3.

	*/
	StorageName string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the schema objects snapshots create params
func (o *SchemaObjectsSnapshotsCreateParams) WithTimeout(timeout time.Duration) *SchemaObjectsSnapshotsCreateParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the schema objects snapshots create params
func (o *SchemaObjectsSnapshotsCreateParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the schema objects snapshots create params
func (o *SchemaObjectsSnapshotsCreateParams) WithContext(ctx context.Context) *SchemaObjectsSnapshotsCreateParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the schema objects snapshots create params
func (o *SchemaObjectsSnapshotsCreateParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the schema objects snapshots create params
func (o *SchemaObjectsSnapshotsCreateParams) WithHTTPClient(client *http.Client) *SchemaObjectsSnapshotsCreateParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the schema objects snapshots create params
func (o *SchemaObjectsSnapshotsCreateParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithClassName adds the className to the schema objects snapshots create params
func (o *SchemaObjectsSnapshotsCreateParams) WithClassName(className string) *SchemaObjectsSnapshotsCreateParams {
	o.SetClassName(className)
	return o
}

// SetClassName adds the className to the schema objects snapshots create params
func (o *SchemaObjectsSnapshotsCreateParams) SetClassName(className string) {
	o.ClassName = className
}

// WithID adds the id to the schema objects snapshots create params
func (o *SchemaObjectsSnapshotsCreateParams) WithID(id string) *SchemaObjectsSnapshotsCreateParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the schema objects snapshots create params
func (o *SchemaObjectsSnapshotsCreateParams) SetID(id string) {
	o.ID = id
}

// WithStorageName adds the storageName to the schema objects snapshots create params
func (o *SchemaObjectsSnapshotsCreateParams) WithStorageName(storageName string) *SchemaObjectsSnapshotsCreateParams {
	o.SetStorageName(storageName)
	return o
}

// SetStorageName adds the storageName to the schema objects snapshots create params
func (o *SchemaObjectsSnapshotsCreateParams) SetStorageName(storageName string) {
	o.StorageName = storageName
}

// WriteToRequest writes these params to a swagger request
func (o *SchemaObjectsSnapshotsCreateParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param className
	if err := r.SetPathParam("className", o.ClassName); err != nil {
		return err
	}

	// path param id
	if err := r.SetPathParam("id", o.ID); err != nil {
		return err
	}

	// path param storageName
	if err := r.SetPathParam("storageName", o.StorageName); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
