//                           _       _
// __      _____  __ ___   ___  __ _| |_ ___
// \ \ /\ / / _ \/ _` \ \ / / |/ _` | __/ _ \
//  \ V  V /  __/ (_| |\ V /| | (_| | ||  __/
//   \_/\_/ \___|\__,_| \_/ |_|\__,_|\__\___|
//
//  Copyright © 2016 - 2022 SeMI Technologies B.V. All rights reserved.
//
//  CONTACT: hello@semi.technology
//

// Code generated by go-swagger; DO NOT EDIT.

package schema

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/semi-technologies/weaviate/entities/models"
)

// SchemaObjectsSnapshotsRestoreStatusReader is a Reader for the SchemaObjectsSnapshotsRestoreStatus structure.
type SchemaObjectsSnapshotsRestoreStatusReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *SchemaObjectsSnapshotsRestoreStatusReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewSchemaObjectsSnapshotsRestoreStatusOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewSchemaObjectsSnapshotsRestoreStatusUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewSchemaObjectsSnapshotsRestoreStatusForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewSchemaObjectsSnapshotsRestoreStatusNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewSchemaObjectsSnapshotsRestoreStatusInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewSchemaObjectsSnapshotsRestoreStatusOK creates a SchemaObjectsSnapshotsRestoreStatusOK with default headers values
func NewSchemaObjectsSnapshotsRestoreStatusOK() *SchemaObjectsSnapshotsRestoreStatusOK {
	return &SchemaObjectsSnapshotsRestoreStatusOK{}
}

/*
SchemaObjectsSnapshotsRestoreStatusOK handles this case with default header values.

Snapshot restoration status successfully returned
*/
type SchemaObjectsSnapshotsRestoreStatusOK struct {
	Payload *models.SnapshotRestoreMeta
}

func (o *SchemaObjectsSnapshotsRestoreStatusOK) Error() string {
	return fmt.Sprintf("[GET /schema/{className}/snapshots/{storageName}/{id}/restore][%d] schemaObjectsSnapshotsRestoreStatusOK  %+v", 200, o.Payload)
}

func (o *SchemaObjectsSnapshotsRestoreStatusOK) GetPayload() *models.SnapshotRestoreMeta {
	return o.Payload
}

func (o *SchemaObjectsSnapshotsRestoreStatusOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.SnapshotRestoreMeta)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewSchemaObjectsSnapshotsRestoreStatusUnauthorized creates a SchemaObjectsSnapshotsRestoreStatusUnauthorized with default headers values
func NewSchemaObjectsSnapshotsRestoreStatusUnauthorized() *SchemaObjectsSnapshotsRestoreStatusUnauthorized {
	return &SchemaObjectsSnapshotsRestoreStatusUnauthorized{}
}

/*
SchemaObjectsSnapshotsRestoreStatusUnauthorized handles this case with default header values.

Unauthorized or invalid credentials.
*/
type SchemaObjectsSnapshotsRestoreStatusUnauthorized struct {
}

func (o *SchemaObjectsSnapshotsRestoreStatusUnauthorized) Error() string {
	return fmt.Sprintf("[GET /schema/{className}/snapshots/{storageName}/{id}/restore][%d] schemaObjectsSnapshotsRestoreStatusUnauthorized ", 401)
}

func (o *SchemaObjectsSnapshotsRestoreStatusUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	return nil
}

// NewSchemaObjectsSnapshotsRestoreStatusForbidden creates a SchemaObjectsSnapshotsRestoreStatusForbidden with default headers values
func NewSchemaObjectsSnapshotsRestoreStatusForbidden() *SchemaObjectsSnapshotsRestoreStatusForbidden {
	return &SchemaObjectsSnapshotsRestoreStatusForbidden{}
}

/*
SchemaObjectsSnapshotsRestoreStatusForbidden handles this case with default header values.

Forbidden
*/
type SchemaObjectsSnapshotsRestoreStatusForbidden struct {
	Payload *models.ErrorResponse
}

func (o *SchemaObjectsSnapshotsRestoreStatusForbidden) Error() string {
	return fmt.Sprintf("[GET /schema/{className}/snapshots/{storageName}/{id}/restore][%d] schemaObjectsSnapshotsRestoreStatusForbidden  %+v", 403, o.Payload)
}

func (o *SchemaObjectsSnapshotsRestoreStatusForbidden) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *SchemaObjectsSnapshotsRestoreStatusForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewSchemaObjectsSnapshotsRestoreStatusNotFound creates a SchemaObjectsSnapshotsRestoreStatusNotFound with default headers values
func NewSchemaObjectsSnapshotsRestoreStatusNotFound() *SchemaObjectsSnapshotsRestoreStatusNotFound {
	return &SchemaObjectsSnapshotsRestoreStatusNotFound{}
}

/*
SchemaObjectsSnapshotsRestoreStatusNotFound handles this case with default header values.

Not Found - Snapshot does not exist
*/
type SchemaObjectsSnapshotsRestoreStatusNotFound struct {
	Payload *models.ErrorResponse
}

func (o *SchemaObjectsSnapshotsRestoreStatusNotFound) Error() string {
	return fmt.Sprintf("[GET /schema/{className}/snapshots/{storageName}/{id}/restore][%d] schemaObjectsSnapshotsRestoreStatusNotFound  %+v", 404, o.Payload)
}

func (o *SchemaObjectsSnapshotsRestoreStatusNotFound) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *SchemaObjectsSnapshotsRestoreStatusNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewSchemaObjectsSnapshotsRestoreStatusInternalServerError creates a SchemaObjectsSnapshotsRestoreStatusInternalServerError with default headers values
func NewSchemaObjectsSnapshotsRestoreStatusInternalServerError() *SchemaObjectsSnapshotsRestoreStatusInternalServerError {
	return &SchemaObjectsSnapshotsRestoreStatusInternalServerError{}
}

/*
SchemaObjectsSnapshotsRestoreStatusInternalServerError handles this case with default header values.

An error has occurred while trying to fulfill the request. Most likely the ErrorResponse will contain more information about the error.
*/
type SchemaObjectsSnapshotsRestoreStatusInternalServerError struct {
	Payload *models.ErrorResponse
}

func (o *SchemaObjectsSnapshotsRestoreStatusInternalServerError) Error() string {
	return fmt.Sprintf("[GET /schema/{className}/snapshots/{storageName}/{id}/restore][%d] schemaObjectsSnapshotsRestoreStatusInternalServerError  %+v", 500, o.Payload)
}

func (o *SchemaObjectsSnapshotsRestoreStatusInternalServerError) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *SchemaObjectsSnapshotsRestoreStatusInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
