//                           _       _
// __      _____  __ ___   ___  __ _| |_ ___
// \ \ /\ / / _ \/ _` \ \ / / |/ _` | __/ _ \
//  \ V  V /  __/ (_| |\ V /| | (_| | ||  __/
//   \_/\_/ \___|\__,_| \_/ |_|\__,_|\__\___|
//
//  Copyright © 2016 - 2022 SeMI Technologies B.V. All rights reserved.
//
//  CONTACT: hello@semi.technology
//

// Code generated by go-swagger; DO NOT EDIT.

package models

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"
)

// SnapshotRestoreMeta The definition of a snapshot metadata
//
// swagger:model SnapshotRestoreMeta
type SnapshotRestoreMeta struct {

	// The class name of a snapshot. Must be URL-safe and work as a filesystem path, only lowercase, numbers, underscore, minus characters allowed.
	ClassName string `json:"className,omitempty"`

	// error message if restoration failed
	Error string `json:"error,omitempty"`

	// The ID of a snapshot. Must be URL-safe and work as a filesystem path, only lowercase, numbers, underscore, minus characters allowed.
	ID string `json:"id,omitempty"`

	// destination path of snapshot files proper to selected storage
	Path string `json:"path,omitempty"`

	// phase of snapshot restoration process
	// Enum: [STARTED TRANSFERRING TRANSFERRED SUCCESS FAILED]
	Status *string `json:"status,omitempty"`

	// Storage name e.g. filesystem, gcs, s3.
	StorageName string `json:"storageName,omitempty"`
}

// Validate validates this snapshot restore meta
func (m *SnapshotRestoreMeta) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateStatus(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

var snapshotRestoreMetaTypeStatusPropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["STARTED","TRANSFERRING","TRANSFERRED","SUCCESS","FAILED"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		snapshotRestoreMetaTypeStatusPropEnum = append(snapshotRestoreMetaTypeStatusPropEnum, v)
	}
}

const (

	// SnapshotRestoreMetaStatusSTARTED captures enum value "STARTED"
	SnapshotRestoreMetaStatusSTARTED string = "STARTED"

	// SnapshotRestoreMetaStatusTRANSFERRING captures enum value "TRANSFERRING"
	SnapshotRestoreMetaStatusTRANSFERRING string = "TRANSFERRING"

	// SnapshotRestoreMetaStatusTRANSFERRED captures enum value "TRANSFERRED"
	SnapshotRestoreMetaStatusTRANSFERRED string = "TRANSFERRED"

	// SnapshotRestoreMetaStatusSUCCESS captures enum value "SUCCESS"
	SnapshotRestoreMetaStatusSUCCESS string = "SUCCESS"

	// SnapshotRestoreMetaStatusFAILED captures enum value "FAILED"
	SnapshotRestoreMetaStatusFAILED string = "FAILED"
)

// prop value enum
func (m *SnapshotRestoreMeta) validateStatusEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, snapshotRestoreMetaTypeStatusPropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *SnapshotRestoreMeta) validateStatus(formats strfmt.Registry) error {

	if swag.IsZero(m.Status) { // not required
		return nil
	}

	// value enum
	if err := m.validateStatusEnum("status", "body", *m.Status); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (m *SnapshotRestoreMeta) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *SnapshotRestoreMeta) UnmarshalBinary(b []byte) error {
	var res SnapshotRestoreMeta
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
